/*
*  Name:      time.cc
*  Author:    Rafael Jesus Alcantara Perez
*  Summary:   UESQLC base SQL type time
*  Date:      $Date: 2002/09/25 23:13:45 $
*  Revision:  $Revision: 1.2 $
*
*  Copyright (C) 2002  Rafael Jesus Alcantara Perez <rafa@dedalo-ing.com>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
*  MA 02111-1307, USA.
*/

#include <uesqlc/time.hh>


//
//  C O N S T R U C T O R S
//

uesql::TTime& uesql::TTime::set (const char* pkcVALUE)
{

  using mpcl::TString;
  using std::atoi;
  using std::size_t;
  using std::string;
  using std::time_t;

// <FIXME comment="must check for invalid times">
  setNull ( !pkcVALUE || !*pkcVALUE );
  if ( !isNull() )
  {
    int       iSecond;
    int       iMinute;
    int       iHour;
    TString   yValue (pkcVALUE);
    size_t    zBegin = 0;
    size_t    zEnd   = 0;

    //
    //  First it cleans the source date, and then obtains the hour.
    //
    yValue.suppressFirst ('\'');
    yValue.suppressLast ('\'');
    zEnd = yValue.find (':');
    if ( zEnd == string::npos )
    {
      setNull (true);
      throw mpcl::TExceptionEL_Constraint ("invalid date", __FILE__, __LINE__);
    }
    else
    {
      //
      //  First it obtains the hour value. Second it obtains the minute and the
      //  second value.
      //
      iHour   = atoi (yValue.substr (0, zEnd).c_str());
      zBegin  = zEnd + 1;
      zEnd    = yValue.find (':', zBegin);
      if ( zEnd == string::npos )
      {
        setNull (true);
        throw mpcl::TExceptionEL_Constraint ("invalid date", __FILE__, __LINE__);
      }
      else
      {
        iMinute = atoi (yValue.substr (zBegin, zEnd - zBegin).c_str());
        iSecond = atoi (yValue.substr (zEnd + 1).c_str());
        TLocalDate::set (1970, 1, 1, iHour, iMinute, iSecond);
      }
    }
  }
// </FIXME>
  return *this;
  
}  // set()
