/*
*  Name:      TIdentifier.java
*  Author:    Rafael Jesus Alcantara Perez
*  Summary:   SQL type identifier.
*  Date:      $Date: 2002/09/28 18:54:48 $
*  Revision:  $Revision: 1.4 $
*
*  Copyright (C) 2002  Rafael Jesus Alcantara Perez <rafa@dedalo-ing.com>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
*  MA 02111-1307, USA.
*/

///  Package for UESQL.
package org.uesqlc;


/**
*  SQL type for identifiers  (such as the name of an attribute, relation, view,
*  schema, cursor, etc.).
*/
public class TIdentifier extends TString
{

  //
  //  C O N S T R U C T O R S
  //

  /**
  *  Builds a new instance.
  *  @post ( isNull() )
  */
  public TIdentifier()
  {
    super();
  }

  /**
  *  Builds a new instance.
  *  @param ktIDENTIFIER Source identifier.
  *  @post ( isNull() == ktIDENTIFIER.isNull() )
  */
  public TIdentifier (final TIdentifier ktIDENTIFIER)
  {
    super (ktIDENTIFIER.toString());
  }

  /**
  *  Builds a new instance.
  *  @param kySTRING Source string.
  *  @post ( isNull() == ( null == kySTRING ) )
  */
  public TIdentifier (final String kySTRING)
  {
    super (kySTRING);
  }


  //
  //  S E L E C T O R S
  //

  public String get()
  {

    String   yResult;

    if ( isNull() )
    {
      yResult = "null";
    }
    else
    {
      yResult = yValue.toString();
    }
    return yResult;

  }  // get()

}  // class TIdentifier
